Index: squid/src/store.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store.c,v
retrieving revision 1.16.2.1
retrieving revision 1.16.2.2
diff -u -r1.16.2.1 -r1.16.2.2
--- squid/src/store.c	24 Nov 2001 05:51:40 -0000	1.16.2.1
+++ squid/src/store.c	21 May 2002 02:46:43 -0000	1.16.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store.c,v 1.16.2.1 2001/11/24 05:51:40 jkay Exp $
+ * $Id: store.c,v 1.16.2.2 2002/05/21 02:46:43 jkay Exp $
  *
  * DEBUG: section 20    Storage Manager
  * AUTHOR: Harvest Derived
@@ -194,12 +194,22 @@
 	e, storeKeyText(key));
     e->hash.key = storeKeyDup(key);
     hash_join(store_table, &e->hash);
+#if USE_HINT_CACHE
+    if (HINT_CACHE_ACTIVE()) {
+	e->hchhash.key = e->hash.key;
+	hash_join(cache_table, &e->hchash);
+    }
+#endif
 }
 
 static void
 storeHashDelete(StoreEntry * e)
 {
     hash_remove_link(store_table, &e->hash);
+#if USE_HINT_CACHE
+    if (HINT_CACHE_ACTIVE())
+	hash_remove_link(hint_table, &e->hchash);
+#endif
     storeKeyFree(e->hash.key);
     e->hash.key = NULL;
 }
@@ -1007,6 +1017,20 @@
     storeInitHashValues();
     store_table = hash_create(storeKeyHashCmp,
 	store_hash_buckets, storeKeyHashHash);
+#if USE_HINT_CACHE
+    /*
+     * Need to be able to look up objects from hint
+     * cache key so we can invalidate obsolete objects
+     * based on hint cache updates.
+     * Note: the hint cache key is just the first 8 bytes
+     * of the 16-byte cache key, so storeKeyHashHash will
+     * always work.  Although, right now, sKHH only looks
+     * at the first 32 bits anyway, giving double protection.
+     */
+    if (HINT_CACHE_ACTIVE()) 
+	hint_table = hash_create(hintCacheURLKeyCompare,
+		 store_hash_buckets, storeKeyHashHash);
+#endif
     mem_policy = createRemovalPolicy(Config.memPolicy);
     storeDigestInit();
     storeLogOpen();
@@ -1063,6 +1087,12 @@
     if (store_digest)
 	cacheDigestDestroy(store_digest);
 #endif
+#if USE_HINT_CACHE
+    if (HINT_CACHE_ACTIVE()) {
+	hashFreeMemory(hint_table);
+	hint_table = NULL;
+    }
+#endif
     store_digest = NULL;
 }
 
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.47.2.5
retrieving revision 1.47.2.6
diff -u -r1.47.2.5 -r1.47.2.6
--- squid/src/structs.h	8 Jan 2002 09:10:40 -0000	1.47.2.5
+++ squid/src/structs.h	21 May 2002 02:46:43 -0000	1.47.2.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.47.2.5 2002/01/08 09:10:40 hno Exp $
+ * $Id: structs.h,v 1.47.2.6 2002/05/21 02:46:43 jkay Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -339,7 +339,7 @@
 
 #if USE_HINT_CACHE
 struct _URLKey {
-  GenericKey key;
+  HintCacheKey key;
 };
 #endif
 
@@ -1555,7 +1555,7 @@
     swap_status_t swap_status:3;
     Updatee *updatees;
 #if USE_HINT_CACHE
-    URLKey key;          /* 64-bit MD5 hash of URL */
+    hash_link hchash;
 #endif
 };
 
@@ -2264,18 +2264,18 @@
 
 /* Hint Cache Interface */
 /*
- * Primitive data types. All have a Net_ format which has an
+ * Primitive data types. All have a -Net format which has an
  * agreed-upon endian-ness.
  */
 
 
-struct _Net_URLKey {
-    GenericKey mungedKey;
+struct _URLKeyNet {
+    HintCacheKey mungedKey;
 };
 
 struct _NodeKey {
-    List_Links links;   /* MUST BE FIRST FIELD OF STRUCT */
-    GenericKey key;
+    dlink_node links;
+    HintCacheKey key;
     struct sockaddr_in addr;
 };
 
@@ -2288,8 +2288,8 @@
 };
 
 /* This is what goes onto the net */
-struct _Net_HintCacheEntry {
-    Net_URLKey     mungedKey;
+struct _HintCacheEntryNet {
+    URLKeyNet     mungedKey;
     struct in_addr mungedIpaddr;
     unsigned short mungedPort;
     short          mungedPad;
@@ -2305,13 +2305,13 @@
     HintCacheEntry                entry;
 };
 
-struct _Net_HintCacheUpdate {
+struct _HintCacheUpdateNet {
     unsigned char          mungedAction;
     char                   mungedHopcount;
     char                   mungedUNUSED; 
     char                   mungedPad1;
     int                    mungedPad2;
-    Net_HintCacheEntry     mungedEntry;
+    HintCacheEntryNet      mungedEntry;
 };
 
 /* Hint Cache Disk */
Index: squid/src/typedefs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/typedefs.h,v
retrieving revision 1.25.2.4
retrieving revision 1.25.2.5
diff -u -r1.25.2.4 -r1.25.2.5
--- squid/src/typedefs.h	22 Dec 2001 16:34:34 -0000	1.25.2.4
+++ squid/src/typedefs.h	21 May 2002 02:46:43 -0000	1.25.2.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: typedefs.h,v 1.25.2.4 2001/12/22 16:34:34 jkay Exp $
+ * $Id: typedefs.h,v 1.25.2.5 2002/05/21 02:46:43 jkay Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -371,20 +371,20 @@
 /* Hint Cache Interface */
 typedef unsigned Net_unsigned;
 typedef long long unsigned Net_longlong;
-typedef unsigned long long GenericKey;
+typedef unsigned long long HintCacheKey;
 typedef struct _URLKey URLKey;
-typedef struct _Net_URLKey Net_URLKey;
+typedef struct _URLKeyNet URLKeyNet;
 typedef struct _NodeKey NodeKey;
 typedef struct _HintCacheEntry HintCacheEntry;
-typedef struct _Net_HintCacheEntry Net_HintCacheEntry;
+typedef struct _HintCacheEntryNet HintCacheEntryNet;
 typedef struct _HintCacheUpdate HintCacheUpdate;
-typedef struct _Net_HintCacheUpdate Net_HintCacheUpdate;
+typedef struct _HintCacheUpdateNet HintCacheUpdateNet;
 
 /* Hint Cache Disk */
 typedef struct _HintCacheDiskEntry HintCacheDiskEntry;
 typedef struct _HintCacheDisk HintCacheDisk;
 
-typedef List_Links *HintCacheNodeListIter;
+typedef dlink_node *HintCacheNodeListIter;
 #endif /* USE_HINT_CACHE */
 
 #if USE_ICP_DATA
